#include <cmath>
#include <cstdlib>
#include <cstring>
#include <cstdio>

#define N_VALUES 10000000

#define REAL_FLAG 1  // (1=float, 2=double)

#if REAL_FLAG == 1
#define REAL_TYPE float
#define HIGHER_REAL_TYPE double
#define HIGHER_ZERO 0.0
#endif

#if REAL_FLAG == 2
#define REAL_TYPE double
#define HIGHER_REAL_TYPE __float128
#define HIGHER_ZERO 0.0Q
#endif

using namespace std;

REAL_TYPE summation_simple( const REAL_TYPE a[], const size_t n_values )
{
    REAL_TYPE sum = 0.0;
    for( int i = 0; i < n_values; i++ ) {
        sum += a[ i ];
    }
    return sum;
}

REAL_TYPE summation_higher( const REAL_TYPE a[], const size_t n_values )
{
    HIGHER_REAL_TYPE sum = HIGHER_ZERO;
    for( int i = 0; i < n_values; i++ ) {
        sum += (HIGHER_REAL_TYPE)a[ i ];
    }
    return (REAL_TYPE)sum;
}

REAL_TYPE summation_kahan( const REAL_TYPE a[], const size_t n_values )
{




}

static void init_values( const int a_size, REAL_TYPE* a ) {
    REAL_TYPE scale = 1.0 / ( REAL_TYPE )RAND_MAX;
    for ( int i = 0; i < a_size; i++ ) {
        REAL_TYPE temp = scale * ( REAL_TYPE )random();
        if (i%4 == 0) a[i] =  -100.0 * temp ;
        if (i%4 == 1) a[i] =  0.001  * temp ;
        if (i%4 == 2) a[i] =  100.0  * temp ;
        if (i%4 == 3) a[i] =  -0.001 * temp ;
    }
}

int main( int argc, char* argv[] ) {

    REAL_TYPE array[ N_VALUES];

    REAL_TYPE summ;

    init_values( N_VALUES, array );

    summ = summation_simple( array, N_VALUES);
    printf( "Summation simple  :   %20.17f \n", summ);

    summ = summation_kahan ( array, N_VALUES);
    printf( "Summation Kahan   :   %20.17f \n", summ);

    summ = summation_higher  ( array, N_VALUES);
    printf( "Summation higher  :   %20.17f \n", summ);
}
